#!/usr/bin/perl
#AIM Sniff Copyright (C) 2002 Shawn Grimes
#This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as 
#published by the Free Software Foundation; version 2 of the License.
# This program is distributed in the hope that it will be useful, but 
#WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
#or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
#more details.
#You should have received a copy of the GNU General Public License along with 
#this program; if not, write to the 
#Free Software Foundation, Inc.
#59 Temple Place, Suite 330
#Boston, MA 02111-1307 USA

#You may also contact me directly with any questions at: 
#grimessh@users.sourceforge.net
#OR on AIM: spittingfire101 (let me know you are talking about AIM Sniff)
#And of course the mailing list: aimsniff-devel@lists.sourceforge.net

#use strict;
use Net::Pcap;
use NetPacket::Ethernet qw(:strip);
use NetPacket::IP qw(:strip);
use NetPacket::TCP;
use DBI;
use Unicode::String qw(utf8 latin1 utf16);

#CHANGE
#Attempting to intercept ctrl-c
$SIG{'QUIT'}=\&LeaveNow;
$SIG{'INT'}=\&LeaveNow;

######################################################################
#########   User Defined Variables                           #########
######################################################################
$debug=0;
$driver="mysql";
$database="aim";
$host="mysql.server.com";
$user="username";
$password="password";
######################################################################
#########   End User Defined Variables--Modify nothing below #########
######################################################################

my($ver)='0.6';


###
#Set counts=0
###
$msgCount=0;
$loginCount=0;
$fileCount=0;


####
#Get command line arguments
####
&getOptions(@ARGV) || die "Could not get options\n";



if(defined($getHandles)){
    &getFromHandle || die "Could not get SMB Names\n"; ##Used to find out who messages are coming from in the database.  
}else{
    if(defined($dumpfile)){ #work in offline mode?
	print "Working in Offline Mode\n******************\nReading File: $dumpfile\n\n";
	$pcap_t = Net::Pcap::open_offline($dumpfile, \$err);
	die "Error opening file: $err\n" if(!defined($pcap_t));

    }else{  #actively sniff
	print "Beginning Sniff:\n*************\n\n" if(!$quiet);
	####Command Line Options
	$dev='eth0' if(!defined($dev));
	$filter_str='tcp and port 5190' if(!defined($filter_str));
	$promisc=1 if(!defined($promisc));
	$to_ms=1000 if(!defined($to_ms));

	###These shouldn't be changed (yet)
	$optimize=0;
	$netmask=0;
	$snaplen=50000;
	$pcap_t=Net::Pcap::open_live($dev, $snaplen, $promisc, $to_ms, \$err) || die "Error opening pcap: $err\n"; #start sniffing
	$result=Net::Pcap::compile($pcap_t, \$filter_t, $filter_str,$optimize,$netmask); #compile filter_str
	Net::Pcap::setfilter($pcap_t, $filter_t); #apply filter
    }
    Net::Pcap::loop($pcap_t, $count, \&process_pkt,"xyz"); #start to process the packets that are received
}


#Process the packet
sub process_pkt {
    my($user, $hdr, $pkt) = @_;
    if (!defined($hdr) or !defined($pkt)) {
	print("Bad args passed to callback\n");
	print("Bad user data\n"), if ($user ne "xyz");
	print("Bad pkthdr\n"), if (!defined($hdr));
	print("Bad pkt data\n"), if (!defined($pkt));
	print("not ok\n");
	exit;
    }
    my(%sqlAdd, @printValues);
#get datetimestamp of packet
    ($sec, $min, $hour, $mday, $mon, $year)=localtime($hdr->{tv_sec});
    $year+=1900;
    $mon+=1;	
    $datestamp="$year-$mon-$mday $hour:$min:$sec";

#Strip Ethernet portion of packet off
    $ip_obj=NetPacket::IP->decode(eth_strip($pkt));
    $srcip=$ip_obj->{src_ip};
    $dstip=$ip_obj->{dest_ip};
    $tcp_obj=NetPacket::TCP->decode(ip_strip(eth_strip($pkt)));
    $flags=$tcp_obj->{flags};  #make sure packet contains ACK PUSH

    $dataset=$tcp_obj->{data};
    ($family,$dataset)=&familyFind($dataset); #get Family ID and SubID

    #Have to better modularize so that plugins can be easily added
    #AIM Messages
    if(($family == '00040006' or $family == '00040007')){ #AIM Message
	($chanid,$dataset)=&idFind($dataset); #Get 8 byte id before handle, not sure what it's for yet
	if($chanid == '0001'){
	    ($handle,$dataset)=&handleFind($dataset); #Get AIM Handle
	    $msg=&msgFind($dataset); #Get the message
	    if($family == '00040007' and $handle and $msg){
#CHANGE
#move @sqlAdd to associative array
		    %sqlAdd=('table',"logs",'ts',$datestamp,'handle',$handle, 'direction',$family, 'message', $msg,'ip', $dstip);
		    #CHANGE
#moved msgClean down to &printOUT
		    @printValues=($datestamp, $handle, $family, $msg, $dstip, $convid);
		    $msgCount++;
	    }elsif($family=='00040006' and $handle and $msg){
#CHANGE
#changed @sqlAdd to an associate array
		%sqlAdd=('table',"logs",'ts',$datestamp,'handle',$handle, 'direction',$family, 'message', $msg,'ip', $srcip) if($handle and $msg);
		@printValues=($datestamp, $handle, $family, $msg, $srcip, $convid) if($handle and $msg);
		$msgCount++;
	    }
#CHANGE
#used to get file transfers and other channel 0002 data
	}elsif ($family=='00040006' or $family=='00040007'){
	    my($handle, $capString, $lang, $format, $fileMsg, $ip, $port, $filename)=&getFile($dataset);
	    my($msg)="File Xfer Detected:<BR>\nCapabilities: $capString<BR>\nLanguage: $lang<BR>\nFormat:$format<BR>\nMSG: $fileMsg<BR>\nIP: $ip<BR>\nPort: $port<BR>\nFile: $filename<BR>\n";
	    %sqlAdd=('table','logs','ts',$datestamp,'handle',$handle,'direction',$family,'message',$msg,'ip',$srcip) if($handle and $filename);
	    @printValues=($datestamp, $handle,$family,$msg, $srcip) if($handle and $filename);
	    $fileCount++;
	}
	    #AIM Logins
#CHANGED
#get login information even if SMB is not chosen
    }elsif($family == '00170006'){ #AIM Login
	$handle=&getSignon($dataset); #Get AIM Handle
	if(defined($SMB)){
	    ($SMBMachine, $SMBUser)=&SMBInfo($srcip);
	    print "\nAIM Login:\n$SMBUser on $SMBMachine logged on as $handle\n\n" if(!($quiet) and ($SMBMachine) and ($SMBUser)); #print to STDOUT
	    %sqlAdd=('table',"handles",'ts',$datestamp,'handle',$handle, 'username',$SMBUser,'machine',$SMBMachine,'ip',$srcip) if($SMBMachine and $SMBUser);
	}else{
	    print "\nAIM Login: $handle is using $srcip\n" if($handle);
	    %sqlAdd=('table',"handles",'ts',$datestamp,'handle',$handle,'ip',$srcip) if($handle);
	}
	$loginCount++;
	
	
    #AIM Version Information
    }elsif($family=='000170002'){
	($handle, $version, $country, $language)=&getVersion($dataset);
	if($handle and $version){
	    print "\nVersion Information:\n$handle is using $version with country=$country and language=$language\n\n" if(! $quiet);
	    %sqlAdd=('table',"versions",'ts',$datestamp,'ip',$srcip, 'handle',$handle, 'version', $version,'country', $country, 'language',$language) if($handle and $version);
	}
    }

    &mysqlAdd(%sqlAdd) if(!$nodb and %sqlAdd);
    &printOUT(@printValues) if(!$quiet and @printValues);
	
}



sub familyFind{
#Find family id
	my($dataset)=@_;
        $family="";
        if(length($dataset) > 0){
		$dataportion=utf16($dataset);  #Changed this to utf16 because utf8 was dropping some bytes
		$dataportion=$dataportion->hex;
		$dataportion=~s/U\+//g;
#CHANGE
#Regex was too specific and I was only getting logon and AIM messages, I may want other controls in the future
		if ($dataportion=~s/^2a02 [0-9a-f]{4} [0-9a-f]{4} (00[a-f0-9]{2} 00[a-f0-9]{2})//){
		    $family=$1;
		    $family=~s/\s//g;
		}else{
		    $family=""
		}
#CHANGE
#remove spaces from $dataset before returning
		$dataportion=~s/\s//g;
	 }
	return $family, $dataportion;
}

sub getSignon{
#Find AIM Handle
    my($dataset)=@_;
    my($handle, $lengthHandle, @bit)="";
#CHANGE
#adjusted to not look for spaces
    $dataset=~s/^.*000100([0-9a-f]{2})//;
    $lengthHandle=hex($1);
    $dataset=~s/^(([a-f0-9]{2}){$lengthHandle})//;
    $handle=&convertHex($1);
    return $handle;
}

sub SMBInfo{
#Get SMB machine name and username
    my($ip)=@_;
    my(@SMBInfo)=`nmblookup -A $ip`;
    my($SMBInfo);
    if($SMBInfo[1]!~/ACTIVE/){
	print "Didn't find nmblookup entry: $SMBInfo[1]\n" if $debug;
	$SMBName="";
	$username="";
    }else{
	$SMBName=$SMBInfo[1];
	$SMBName=~/(.*)\<.*/;
	$SMBName=$1;
	$SMBName=~s/\s//;
	$SMBName=~s/\<.*//;
	$SMBName=utf8($SMBName);
	$SMBName=$SMBName->hex;
	$SMBName=~s/U\+00//g;
	$SMBName=~s/\s20//g;
	@digis=split(/\s/,$SMBName);
	$SMBName="";
	foreach $digi(@digis){
	    $te=chr(hex($digi));
	    $SMBName.=$te;
	}
			    
	##Get user name
	$count=2;
	while($SMBInfo[$SMBInfo-$count]=~/SMS/ || $SMBInfo[$SMBInfo-$count]!~/03/){ #Don't use SMS accounts
	    $count++;
	}
	$username=$SMBInfo[$SMBInfo-$count];
	$username=~/(.*)\s*\<03\>.*/;
	$username=$1;
	$username=~s/\s//;
	$username=utf8($username);
	$username=$username->hex;
	$username=~s/U\+00//g;
	$username=~s/\s20//g;
	@digis=split(/\s/,$username);
	$username="";
	foreach $digi(@digis){
	    $te=chr(hex($digi));
	    $username.=$te;
	}
    }
    return $SMBName, $username;
}

sub idFind{
    #Gets 8 byte id before handle length and handle is sent
    my($dataset)=@_;
    $dataset=~s/[0-9a-f]{28}([a-f0-9]{4})//;
    $chanid=$1;
    return $chanid, $dataset;
}
    

sub handleFind{
#Find AIM handle
    my($dataset)=@_;
    my($handle, $count, @bits, $lengthHandle, $remove);
    $handle="";
    $dataset=~s/^([a-f0-9]{2})//;
    $lengthHandle=hex($1)*2;
    $dataset=~s/^([a-f0-9]{$lengthHandle})//;
    @bits=split(/([0-9a-f][0-9a-f])/,$1);
    $count=0;
    foreach $byte(@bits){
	$handle.=chr(hex($byte));
    }
    return $handle, $dataset;
}

sub msgFind{
#Find AIM msg
	my($dataset)=@_;
	$msg="";
        $hexcomb=$dataset;
#CHANGED
#I can now pull out the length of the message
	$hexcomb=~s/.*01010?2?010100([a-f0-9]{2})//;
	$length=hex($1)-4;
	$hexcomb=~s/00000000(.*)[00.*]?//;
	$msg=$1;
	$msg=~s/00.*//;
	@bits=split(/([a-f0-9][a-f0-9])/,$msg);
	$msg="";
	foreach $byte(@bits){
	    $msg.=chr(hex($byte));
	}
	return $msg
}

sub msgClean{
#Remove HTML tags from message
    my($msg)=@_;
    $msg=~s/<([^>]|\n)*>//g;
    $msg=~s/\<\/.*//;
    return $msg;
}

sub mysqlAdd{
    my(%values)=@_;
    my($table)=delete $values{'table'};
    my($sql)="";

    $dsn="DBI:$driver:database=$database:host=$host:user=$user:password=$password";
    $dbh=DBI->connect($dsn) || return 0;
    $dbh->{RaiseError}=0;
#CHANGE
#even more generic statements
    $sql="INSERT INTO $table SET ";
    foreach $key(keys %values){
	$value=$dbh->quote($values{$key});
	$value=~s/\\0//g;
	$sql.=" $key=$value,";
    }
    chop($sql);
    $sth=$dbh->prepare($sql) || print "problem preparing: ",$dbh->errstr,"\n";
    if($handle){
	$sth->execute || print "Error executing $DBI::errstr\n";
	print "SQL: $sql\n" if $debug;
    }
}

sub printOUT{
    #Thanks to David Britten for the new output format
    my($datestamp, $handle, $family, $msg, $ip)=@_;
    $msg=&msgClean($msg);
    print "IP: $ip";
    print "<--" if ($family eq "00040007");
    print "-->" if ($family eq "00040006");
    print "$handle - $datestamp\n";
    print "\t$msg\n\n";
}

sub getFromHandle{
    $dsn="DBI:$driver:database=$database:host=$host:user=$user:password=$password";
    $dbh=DBI->connect($dsn) || return 0;
    $dbh->{RaiseError}=0;
   
    $sql="SELECT id, ip, ts FROM logs WHERE direction='00040006' and fromHandle is NULL or fromHandle=''";
    $sth=$dbh->prepare($sql) || die "problem preparing: ",$dbh->errstr,"\n";
    $sth->execute || die "Error executing $DBI::errstr\n";
    $sth->bind_col(1, \$id);
    $sth->bind_col(2, \$ip);
    $sth->bind_col(3, \$ts);
    while(@values=$sth->fetchrow_array()){
	$handle="";
	$sql2="SELECT handle FROM handles WHERE ip='$ip' AND ts<'$ts' order by ts desc limit 1";
	$sth2=$dbh->prepare($sql2) || die "Problem preparing: ",$dbh->errstr,"\n";
	$sth2->execute || die "Error executing $DBI::errstr\n";
	$sth2->bind_col(1, \$handle);
	@row=$sth2->fetchrow_array();
	if($handle){
	    $sql2="UPDATE logs SET fromHandle='$handle' WHERE id='$id'"; #Get the last handle logged in from that ip and before that timestamp
	    $sth2=$dbh->prepare($sql2) || die "Problem preparing: ",$dbh->errstr,"\n";
	    $sth2->execute || die "Error executing $DBI::errstr\n";
	}
    }
    print "Lookups complete.\n";
    return 1;
}

sub getVersion{
    my($dataset)=@_;
    my ($handle, $hlength, $version, $language, $country, $type, $value)="";
    $dataset=~s/^[a-f0-9]{12}//;
    while($type!~/4a/){
	$dataset=~s/^00([a-f0-9]{2})00([a-f0-9]{2})//;
        $type=$1;$len=(hex($2) * 2);
	$dataset=~s/([a-f0-9]{$len})//;
	$value=$1;
	if($type=~/01/){
	    $handle=&convertHex($value);
	}elsif($type=~/03/){
	    $version=&convertHex($value);
	}elsif($type=~/0f/){
	    $language=&convertHex($value);
	}elsif($type=~/0e/){
	    $country=&convertHex($value);
	}
    }
    return $handle, $version, $country, $language;
    
}

sub getFile{
    my($dataset)=@_;
    my($handle, $lenHandle, $ip,$msg,$filename,$lang,$format)="";
    $dataset=~s/^([a-f0-9]{2})//;
    $lenHandle=hex($1) * 2;
    $dataset=~s/^([a-f0-9]{$lenHandle})//;
    $handle=&convertHex($1);
    $dataset=~s/0005(00[a-f0-9]{2})//;
    $lenPacket=hex($1);
    $dataset=~s/([a-f0-9]{4})//;
    $flags=$1;
    if($flags=='0000'){
	$dataset=~s/([a-f0-9]{16})//;
	$cookie=$1;
	$dataset=~s/.*(0946[a-f0-9]*53540000)//;
	$capString=$1;
	$type='1';
	while($type && $dataset){
	    $dataset=~s/^([a-f0-9]{4})([a-f0-9]{4})//;
	    $type=$1;$len=(hex($2) * 2);
	    print "TYPE: $type\nLENGTH: $len\n" if $debug;
	    if($type!~/000f/){
		$dataset=~s/([a-f0-9]{$len})//;
		$value=$1;
	    }
	    if($type=~/000e/){ #Language
		$lang=&convertHex($value);
	    }elsif($type=~/000d/){ #Format
		$format=&convertHex($value);
	    }elsif($type=~/2711/){ #File Name
		$value=~s/^00010001[a-f0-9]{8}//;
		$value=~s/00.*//;
		$filename=&convertHex($value);
	    }elsif($type=~/0005/){ #Port Number
		$port=hex($value);
	    }elsif($type=~/0003/){ #IP Address
		@octets=split('([a-f0-9]{2})',$value);
		foreach $octet(@octets){
		    $octet=hex($octet) if ($octet);
		    $ip.=$octet . "." if($octet);
		}
		$ip=~s/\.$//;
	    }elsif($type=~/000c/){ #Message
		$msg=&convertHex($value);
	    }
	}			 
	return ($handle, $capString, $lang, $format, $msg, $ip, $port, $filename);
    }else{
	return 0;
    }
}

#CHANGE
#added this function to convert hex to string for me
sub convertHex{
    my($value)=@_;
    @bits=split(/([a-f0-9][a-f0-9])/,$value);
    $msg="";
    foreach $byte(@bits){
	$msg.=chr(hex($byte));
    }
    return $msg;
}

sub getOptions{
    my(@ARGV)=@_;
    if($ARGV[0]=~/-C=(.*)/){
	$configfile=$1;
	open(CONFIG,"$configfile") || print "Error opening config file, using defaults instead.\n";
	while(<CONFIG>){
	    $arg=$_;
	    if($arg!~/^#/){
	       $dumpfile=$1 if($arg=~/dumpfile=(.*)/);
	       $count=$1 if($arg=~/packetCount=(.*)/);
	       $dev=$1 if($arg=~/dev=(.*)/);
	       $filter_str=$1 if($arg=~/filter='(.*)'/);
	       $promisc=1 if ($arg=~/promisc=1/);
	       $to_ms=$1 if ($arg=~/timeout=(.*)/);
	       $nodb=1 if ($arg=~/nodb=1/);
	       $quiet=1 if ($arg=~/quiet=1/);
	       $SMB=1 if ($arg=~/SMB=1/);
	       $host=$1 if ($arg=~/host=(.*)/);
	       $user=$1 if ($arg=~/user=(.*)/);
	       $password=$1 if ($arg=~/password=(.*)/);
	   }
	}
	print "SECOND ARG IS: $ARGV[1]\n";
	$getHandles=1 if($ARGV[1]=~/--getHandles/);
	print "Running with: \tdumpfile=$dumpfile\n\tpacketCount=$count\n\tdev=$dev\n\tfilter=$filter_str\n\tpromisc=$promisc\n\ttimeout=$to_ms\n\tSMB=$SMB\n\tnodb=$nodb\n\tquiet=$quiet\n\thost=$host\n\tuser=$user\n\tpassword=****\n\n";

    }else{
	foreach $arg (@ARGV){
	    $getHandles=1 if($arg=~/--getHandles/);
	    $dumpfile=$1 if($arg=~/-r=(.*)/);
	    $count=$1 if($arg=~/-c=(.*)/);
	    $dev=$1 if($arg=~/-d=(.*)/);
	    $filter_str=$1 if($arg=~/-f='(.*)'/);
	    $promisc=1 if ($arg=~/-p/);
	    $to_ms=$1 if ($arg=~/-to=(.*)/);
	    $nodb=1 if ($arg=~/--nodb/);
	    $quiet=1 if ($arg=~/--quiet/);
	    $SMB=1 if ($arg=~/--SMB/);
	    if($arg=~/--h/ or $arg=~/-h/){
		print "**************\nAimSniff $ver\n**************\n";
		print "AIM Sniff Copyright (C) 2002 Shawn Grimes\n";
		print "This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; version 2.\n";
		print "This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.\n";
		print "You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA\n";
		print "You may also contact me directly with any questions at: grimessh\@users.sourceforge.net\n";
		print "\n###########\nTo use:\n";
		print "\t-C=filename <-Get AIM Sniff options from a config file\n";
		print "\t-r=filename <-Read a PCAP file instead of doing a live capture\n";
		print "\t-c=integer <-The number of packets to read before quitting\n";
		print "\t-d=dev <-The device to capture packets from\n";
		print "\t-f='filter string' <-String to filter on enclosed in single quotes\n\t\t(DEFAULT: 'tcp and port 5190') -- Should only have to be specified if you think AIM is running on a different port\n";
		print "\t-p <-Place the device into promiscuous mode\n";
		print "\t-to=integer <-Read timeout in ms\n";
		print "\t--SMB <-Turn SMB lookups 'on' to get NT domain usernames with AIM logins, Off by default\n";
		print "\t--nodb <-Do not dump to a DB, only dump to STDOUT\n";
		print "\t--quiet <-Do not print anything but errors to STDOUT\n";
		print "\t--getHandles <-Do not do anything with PCAP but populate the fromHandle field in the logs table\n";
		print "\nDefaults:\n";
		print "\t-d=eth0\n\t-f='tcp and port 5190'\n\t-p\n\t-to=1000\n";
		exit;
	    }
	}
    }
    return 1;
}

sub LeaveNow{
    Net::Pcap::stats($pcap_t, \%stats);
      print "Packets Received: $stats{'ps_recv'}\nPackets Dropped: $stats{'ps_drop'}\nPackets Dropped by interface: $stats{'ps_ifdrop'}\n";
      print "Messages found: $msgCount\nLogins found: $loginCount\nFile Xfers: $fileCount\n\n";
      exit;
  }
