#!/usr/bin/perl
use DBI;


######################################################################
######################################################################
#########   User Defined Variables                           #########

$debug=0;
$driver="mysql";
$database="aim";
$host="mysql.server.com";
$user="aim";
$password="whyaskme";
$limit=25; #messages per screen
$gifloc="./aimsniff/"; #location of the gif images included

######################################################################
######################################################################
######################################################################

$ver='0.6';

$dsn="DBI:$driver:database=$database:host=$host:user=$user:password=$password";

$dbh=DBI->connect($dsn) || return 0;
$dbh->{RaiseError}=0;

&printHeader;

$query=$ENV{'QUERY_STRING'};

($command,@options)=&getCommand($query);

print "COMMAND: $command<BR>OPTIONS: @options\n<BR>OPTION STR: $optionstr<BR>" if($debug);


print "QUERY: $ENV{'QUERY_STRING'}<BR><BR>\n" if($debug);

if($command=~/SORT/){
    $sql=&cmdSort(@options);
}elsif($command=~/GETINFO/){
    $sql=&cmdGetInfo(@options) || print "<h1>Could not get info</H1><p>";
}elsif($command=~/DELETE/){
    &cmdDelete(@options) || print "<h1>Could not delete</h1><p>";
}


&printConversations($sql);

$page=pop(@options) if($options[$options-1]=~/^\d/);
$optionstr=join '+' , @options;
&printFooter($command, $optionstr, $page, $sql);

sub printHeader{
    print "Content-type:text/html\n\n";
    print "<HTML><HEAD><TITLE>AIM Sniff WebView $ver</TITLE></HEAD><BODY bgcolor=#33CCCC>";
}
sub printFooter{
    my($command, $optionstr, $curPage,$sql)=@_;
    print "</TABLE><BR>";
    if($sql){
	$sql=~s/SELECT .* (FROM .*) LIMIT//i;
	$sql="SELECT count(id) $1";
    }else{
	$sql="SELECT count(id) FROM logs";
    }
    my($sth)=$dbh->prepare($sql) || print "problem preparing: ",$dbh->errstr,"\n";
    $sth->execute || print "Error executing $DBI::errstr\n";
    @values=$sth->fetchrow_array;
    $totCount=$values[0];
    $pages=$totCount/$limit;
    if($pages=~s/\..*//){$pages++};
    print "Total Results: $totCount<BR>";
    if($curPage && $pages > 1 ){
	print "Total Pages: $pages<BR>";
	for($x=1;$x<=$pages;$x++){
	    if($page ne $x){
		print "&nbsp &nbsp<a href='./aimsniff.cgi?$command=$optionstr+$x'>$x</a>";
	    }else{
		print "&nbsp &nbsp $x";
	    }
	}
    }elsif($pages > 1){
	print "&nbsp &nbsp 1";
	for($x=2;$x<=$pages;$x++){
		print "&nbsp&nbsp<a href='./aimsniff.cgi?$command=$optionstr+$x'>$x</a>";
	}
    }
    print "<BR><BR>AIM Sniff WebView $ver<BR>Brought to you by: Shawn Grimes<BR>\n";
    print "</BODY></HTML>";
}

sub getCommand{
    my($CGI)=@_;
    if(!$CGI){
	return 0,0;
    }else{
	$CGI=~/(.*)=(.*)/;
	$command=$1; $options=$2;
	@options=split(/\+/, $options);
	if($CGI=~/=\+(\d*)/){
	    @options=$1;
	   
	}
	return $command, @options;
    }
}

sub cmdSort{
    my($heading, $direction, $page)=@_;
    if($page && $page ne "1"){
	print "$heading<BR>$direction<BR>$page<BR>\n" if($debug);
	$start=($limit*($page-1))-1;
	$sql="SELECT * FROM logs ORDER BY $heading $direction limit $start, $limit";
    }else{
	$sql="SELECT * FROM logs ORDER BY $heading $direction limit $limit";
    }
    return $sql;
}

sub cmdGetInfo{
    my($handle)=@_;
    my($sql)="SELECT * FROM handles WHERE handle='$handle' ORDER BY ts DESC limit 1";
    my($sth)=$dbh->prepare($sql) || print "problem preparing: ",$dbh->errstr,"\n";
    $sth->execute || print "Error executing $DBI::errstr\n";
    print '<h1 align="center">Handle Info</h1><BR><table width="50%" border="1" align="center">';
    print '<tr><td>ID</td><td>Timestamp</td><td>IP</td><td>Handle</td><td>Username</td><td>Machine</td></tr>';
    while(@values=$sth->fetchrow_array){
	print "<tr><td>$values[0]</td><td>$values[1]</td><td>$values[2]</td><td>$values[3]</td><td>$values[4]</td><td>$values[5]</td></tr>";
    }
    print '</table><BR><BR>';
    $sql="SELECT * FROM versions WHERE handle='$handle' ORDER BY ts DESC limit 1";
    $sth=$dbh->prepare($sql) || print "problem preparing: ",$dbh->errstr,"\n";
    $sth->execute || print "Error executing $DBI::errstr\n";
    print '<h1 align="center">Version Info</h1><BR><table width="50%" border="1" align="center">';
    print '<tr><td>ID</td><td>Timestamp</td><td>IP</td><td>Handle</td><td>Version</td><td>Country</td><td>Language</td></tr>';
    while(@values=$sth->fetchrow_array){
	print "<tr><td>$values[0]</td><td>$values[2]</td><td>$values[1]</td><td>$values[3]</td><td>$values[4]</td><td>$values[5]</td><td>$values[6]</td></tr>";
    }
    print '</table><BR><BR>';
    $sql="SELECT id, ts, ip, fromHandle, handle, direction, message FROM logs WHERE fromHandle='$handle' or handle='$handle' ORDER BY ts desc limit $limit";
    return $sql;
}

sub cmdDelete{
    my(@ids)=@_;
    $sql="DELETE FROM logs WHERE ";
    foreach $id(@ids){
	$sql.="id=$id or ";
    }
    $sql=~s/.*\sor\s$"//;
    #execute $sql
    return 1;
}

sub printTable{
    my($sql)=@_;
    $sql=~/ORDER BY\s(.*)\s(asc|desc)\s.*/;
    $heading=$1;
    $direction=$2;
    print '<h1 align="center">Messages</h1><BR><table width="100%" border="1">';
    if($heading!~/id/){
	print '<tr><td>ID<a href="./aimsniff.cgi?SORT=id+asc"><IMG SRC="/aim/asc.gif"></a><a href="./aimsniff.cgi?SORT=id+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/asc/){
	print '<tr><td>ID<IMG SRC="/aim/asc_pressed.gif"><a href="./aimsniff.cgi?SORT=id+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/desc/){
	print '<tr><td>ID<a href="./aimsniff.cgi?SORT=id+asc"><IMG SRC="/aim/asc.gif"></a><IMG SRC="/aim/desc_pressed.gif"></td>';
    }

    if($heading!~/ts/){
	print '<td>Date/Time<a href="./aimsniff.cgi?SORT=ts+asc"><IMG SRC="/aim/asc.gif"></a><a href="./aimsniff.cgi?SORT=ts+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/asc/){
	print '<td>Date/Time<IMG SRC="/aim/asc_pressed.gif"><a href="./aimsniff.cgi?SORT=ts+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/desc/){
	print '<td>Date/Time<a href="./aimsniff.cgi?SORT=ts+asc"><IMG SRC="/aim/asc.gif"></a><IMG SRC="/aim/desc_pressed.gif"></td>';
    }

    if($heading!~/ip/){
	print '<td>IP<a href="./aimsniff.cgi?SORT=ip+asc"><IMG SRC="/aim/asc.gif"></a><a href="./aimsniff.cgi?SORT=ip+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/asc/){
	print '<td>IP<IMG SRC="/aim/asc_pressed.gif"><a href="./aimsniff.cgi?SORT=ip+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/desc/){
	print '<td>IP<a href="./aimsniff.cgi?SORT=ip+asc"><IMG SRC="/aim/asc.gif"></a><IMG SRC="/aim/desc_pressed.gif"></td>';
    }


    if($heading!~/handle/){
	print '<td>From</td><td>To<a href="./aimsniff.cgi?SORT=handle+asc"><IMG SRC="/aim/asc.gif"></a><a href="./aimsniff.cgi?SORT=handle+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/asc/){
	print '<td>From</td><td>To<IMG SRC="/aim/asc_pressed.gif"><a href="./aimsniff.cgi?SORT=handle+desc"><IMG SRC="/aim/desc.gif"></a></td>';
    }elsif($direction=~/desc/){
	print '<td>From</td><td>To<a href="./aimsniff.cgi?SORT=handle+asc"><IMG SRC="/aim/asc.gif"></a><IMG SRC="/aim/desc_pressed.gif"></td>';
    }

    print '<td>Message</td>';
    print '<td>Commands:</td></tr>';
    #print "Test\n";
}

sub printConversations{
    &printTable($sql);
    my($sql)=@_;
    if(!$sql){ #print Default layout
	$sql="SELECT id, ts, ip, fromHandle, handle, direction, message FROM logs ORDER BY ts desc limit $limit";
    }

    print "SQL: $sql\n<BR>" if($debug);
    $sth=$dbh->prepare($sql) || print "problem preparing: ",$dbh->errstr,"\n";
    $sth->execute || print "Error executing $DBI::errstr\n";
    while(@values=$sth->fetchrow_array){
	print "<tr>";
	if($values[5]=~/00040007/){
		print qq(<td>$values[0]</td><td>$values[1]</td><td>$values[2]</td><td><a href="./aimsniff.cgi?GETINFO=$values[4]">$values[4]</a></td><td></td><td>$values[6]</td><td>$values[5]</td></tr>);
	    }elsif($values[5]=~/00040006/){
		print qq(<td>$values[0]</td><td>$values[1]</td><td>$values[2]</td><td><a href="./aimsniff.cgi?GETINFO=$values[3]">$values[3]</a></td><td><a href="./aimsniff.cgi?GETINFO=$values[4]">$values[4]</a></td><td>$values[6]</td><td>$values[5]</td></tr>);
	    }
    }
}
